require "pactrack/version"
require "httparty"

module Pactrack
  class Package
    attr_accessor :id
    include HTTParty
    base_uri 'http://server.logistik.posten.se/servlet/PacTrack'
    
    def initialize(id)
      self.id = id
    end
    
    def parcel(force = false)
      force ? @parcel = get_parcel : @parcel||= get_parcel
    end
    
    def events
      parcel['event']
    end
    
    def weight
      parcel['actualweight']
    end
    
    def status
      parcel['statusdescription']
    end
    
    def method_missing(name, *args, &block)
      if parcel.has_key?(name.to_s)
        parcel[name.to_s]
      else
        super
      end
    end
    
    private
    def get_parcel
      self.class.get('?lang=SE&kolliid=' + id)['pactrack']['body']['parcel']
    end
    
  end
end
